/*
 * Copyright (C) 2005-2006 Ruslan Popov <radz@yandex.ru>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _HSV_H
#define _HSV_H 1

#include <gdk-pixbuf/gdk-pixbuf.h>
#include <kino/image_filters.h>
#include <kino/kino_extra.h>
#include <gtk/gtk.h>
#include <glade/glade.h>

#define R 0
#define G 1
#define B 2

#define H 0
#define S 1
#define V 2

#define minimum(a,b) ((a<b) ? a : b )
#define maximum(a,b) ((a>b) ? a : b )

typedef double hsvcolor[3];

class HSVPlugin : public GDKImageFilter
{
 public:
  HSVPlugin();
  ~HSVPlugin();

  char *GetDescription( ) const;
  void FilterFrame( uint8_t *pixels, int width, int height,
		    double position, double delta_frame );
  void AttachWidgets( GtkBin *bin );
  void DetachWidgets( GtkBin *bin );
  void InterpretWidgets( GtkBin *bin );

  void ResetValues( void ) const;
  void Spin2Scale( const gchar * spinname, const gchar * scalename ) const;
  void Scale2Spin( const gchar * scalename, const gchar * spinname ) const;

 private:
  GladeXML * glade;
  GtkWidget * plugin_window;

  double hue;
  double saturation;
  double value;

  void rgb2hsv( uint8_t *pixel, hsvcolor hsv );
  void hsv2rgb( uint8_t *pixel, hsvcolor hsv );
  
};

#endif
